import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    val kotlinVersion = "1.9.21"

    val springVersion = "3.2.0" //latest broken
//    val springVersion = "3.1.6" //works good

    val dependenciesVersion = "1.1.4"

    id("org.springframework.boot") version springVersion

    id("io.spring.dependency-management") version dependenciesVersion
    kotlin("jvm") version kotlinVersion
    kotlin("plugin.spring") version kotlinVersion
}

group = "com.example"
version = "0.0.1-SNAPSHOT"

java {
    sourceCompatibility = JavaVersion.VERSION_17
}

repositories {
    mavenCentral()
}

dependencies {
    implementation("org.springframework.boot:spring-boot-starter-webflux")
    implementation("com.fasterxml.jackson.module:jackson-module-kotlin")

//    implementation("io.projectreactor.kotlin:reactor-kotlin-extensions")
//
//    implementation("org.jetbrains.kotlin:kotlin-reflect")
    implementation("org.jetbrains.kotlinx:kotlinx-coroutines-reactor")
    implementation("org.jetbrains.kotlinx:kotlinx-coroutines-slf4j")

//    implementation("org.springframework.data:spring-data-r2dbc")
//    api("io.r2dbc:r2dbc-pool:0.9.2.RELEASE")
//    api("io.asyncer:r2dbc-mysql:0.9.0")
}

tasks.withType<KotlinCompile> {
    kotlinOptions {
        freeCompilerArgs += "-Xjsr305=strict"
        jvmTarget = "17"
    }
}

tasks.withType<Test> {
    useJUnitPlatform()
}
