package com.example.mdcpoc

import kotlinx.coroutines.slf4j.MDCContext
import kotlinx.coroutines.withContext
import org.slf4j.Logger
import org.slf4j.LoggerFactory
import org.slf4j.MDC
import org.springframework.core.Ordered
import org.springframework.core.annotation.Order
import org.springframework.stereotype.Component
import org.springframework.web.server.CoWebFilter
import org.springframework.web.server.CoWebFilterChain
import org.springframework.web.server.ServerWebExchange
import kotlin.random.Random

//@Component
//@Order(Ordered.LOWEST_PRECEDENCE)
class CoTraceIdFilter : CoWebFilter() {

    companion object {
        val logger: Logger = LoggerFactory.getLogger(this::class.java)
    }

    override suspend fun filter(exchange: ServerWebExchange, chain: CoWebFilterChain) {
        val tid = Random.nextInt(10_000)
        logger.info("CoTraceIdFilter started. tid $tid generated")
        MDC.put("traceId", "tid-$tid")
        withContext(MDCContext()) {
            chain.filter(exchange)
        }
    }
}